"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Build = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime-corejs2/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/asyncToGenerator"));

var _path = require("path");

var _chalk = _interopRequireDefault(require("chalk"));

var _fs = require("fs");

var _helps = require("./helps");

var _logger = require("../lib/utils/logger");

var _build = require("../lib/build");

var REQUIRED_SUBDIRS = ["data", "templates", "deck.config.yml"];

var Build =
/*#__PURE__*/
function () {
  var _ref = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee(args) {
    var dir;
    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (args.help) {
              (0, _helps.logBuildHelp)();
            } // Start


            dir = (0, _path.resolve)(args.path);
            console.log(_chalk.default.green("Building decks in ".concat(dir))); // Check Dependencies

            if (!(0, _fs.existsSync)(dir)) {
              (0, _logger.printAndExit)(_chalk.default.red("No such directory ".concat(dir, ".")));
            }

            REQUIRED_SUBDIRS.forEach(function (subdir) {
              if (!(0, _fs.existsSync)((0, _path.join)(dir, subdir))) {
                (0, _logger.printAndExit)(_chalk.default.red("Couldn't find ".concat(subdir, ". Exiting.")));
              }
            }); // Build

            _context.next = 7;
            return (0, _build.build)(dir);

          case 7:
            // Done
            (0, _logger.printAndExit)(_chalk.default.green("Build complete!"));

          case 8:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function Build(_x) {
    return _ref.apply(this, arguments);
  };
}();

exports.Build = Build;