"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.readConfig = void 0;

var _isArray = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/array/is-array"));

var _regenerator = _interopRequireDefault(require("@babel/runtime-corejs2/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/asyncToGenerator"));

var _fsp = _interopRequireDefault(require("./utils/fsp"));

var _path = _interopRequireDefault(require("path"));

var _jsYaml = _interopRequireDefault(require("js-yaml"));

var readConfig =
/*#__PURE__*/
function () {
  var _ref = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee(projectRoot) {
    var configFile, rawConfig;
    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            configFile = _path.default.join(projectRoot, 'deck.config.yml');
            console.log("...Looking for config in file ".concat(configFile));
            _context.prev = 2;
            _context.t0 = _jsYaml.default;
            _context.next = 6;
            return _fsp.default.readFile(configFile, 'utf8');

          case 6:
            _context.t1 = _context.sent;
            rawConfig = _context.t0.safeLoad.call(_context.t0, _context.t1);
            processConfig(rawConfig);
            return _context.abrupt("return", rawConfig);

          case 12:
            _context.prev = 12;
            _context.t2 = _context["catch"](2);
            console.error("...an error while reading the config: ", _context.t2);
            throw _context.t2;

          case 16:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this, [[2, 12]]);
  }));

  return function readConfig(_x) {
    return _ref.apply(this, arguments);
  };
}();

exports.readConfig = readConfig;

var processConfig = function processConfig(config) {
  for (var key in config) {
    processDeckConfig(config[key], key);
  }
};

var processDeckConfig = function processDeckConfig(deckConfig, deckKey) {
  if (!deckConfig.width) {
    throw "Parameter 'width' is required in deck ".concat(deckKey);
  }

  if (!deckConfig.height) {
    throw "Parameter 'height' is required in deck ".concat(deckKey);
  }

  deckConfig.format = normalizeFormat(deckConfig.format || "svg");
  deckConfig.data = deckConfig.data = "".concat(deckKey, ".csv");
  deckConfig.templateFront = deckConfig.templateFront || "".concat(deckKey, ".js");
};

var normalizeFormat = function normalizeFormat(format) {
  if ((0, _isArray.default)(format)) {
    return format;
  }

  return [format];
};