"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.readData = void 0;

var _from = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/array/from"));

var _regenerator = _interopRequireDefault(require("@babel/runtime-corejs2/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/asyncToGenerator"));

var _papaparse = _interopRequireDefault(require("papaparse"));

var _fsp = _interopRequireDefault(require("./utils/fsp"));

var _path = _interopRequireDefault(require("path"));

var _lodash = _interopRequireDefault(require("lodash"));

var readData =
/*#__PURE__*/
function () {
  var _ref = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee(projectRoot, config) {
    var data, deckKey;
    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            data = {};
            _context.t0 = _regenerator.default.keys(config);

          case 2:
            if ((_context.t1 = _context.t0()).done) {
              _context.next = 9;
              break;
            }

            deckKey = _context.t1.value;
            _context.next = 6;
            return parseCsv(projectRoot, config[deckKey], deckKey);

          case 6:
            data[deckKey] = _context.sent;
            _context.next = 2;
            break;

          case 9:
            return _context.abrupt("return", data);

          case 10:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function readData(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

exports.readData = readData;

var parseCsv =
/*#__PURE__*/
function () {
  var _ref2 = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee2(projectRoot, deckConfig, deckKey) {
    var dataFile, csvFile, csv, csvResult, data;
    return _regenerator.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            dataFile = deckConfig.data;
            csvFile = _path.default.join(projectRoot, 'data', dataFile);
            console.log("...looking for CSV file for deck ".concat(deckKey, " in ").concat(csvFile));
            _context2.next = 5;
            return _fsp.default.readFile(csvFile, 'utf8');

          case 5:
            csv = _context2.sent;
            csvResult = _papaparse.default.parse(csv, {
              header: true
            }); // TODO: Error checking here

            data = csvResult.data;
            return _context2.abrupt("return", explode(deckConfig, data));

          case 9:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function parseCsv(_x3, _x4, _x5) {
    return _ref2.apply(this, arguments);
  };
}();

var explode = function explode(config, data) {
  if (!config.explode) {
    return data;
  }

  return _lodash.default.flatMap(data, function (row) {
    var explosionCount = row[config.explode] || 1;
    return (0, _from.default)({
      length: explosionCount
    }).map(function () {
      return _lodash.default.clone(row);
    });
  });
};