"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.formatCards = void 0;

var _promise = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/promise"));

var _regenerator = _interopRequireDefault(require("@babel/runtime-corejs2/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/asyncToGenerator"));

var _convertSvgToPng = require("convert-svg-to-png");

var _path = _interopRequireDefault(require("path"));

var _rimraf = _interopRequireDefault(require("rimraf"));

var _fsp = _interopRequireDefault(require("./utils/fsp"));

var formatCards =
/*#__PURE__*/
function () {
  var _ref = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee(projectRoot, config, data, renderings) {
    var deckKey;
    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.t0 = _regenerator.default.keys(config);

          case 1:
            if ((_context.t1 = _context.t0()).done) {
              _context.next = 7;
              break;
            }

            deckKey = _context.t1.value;
            _context.next = 5;
            return formatDeck(projectRoot, config[deckKey], data[deckKey], renderings[deckKey], deckKey);

          case 5:
            _context.next = 1;
            break;

          case 7:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function formatCards(_x, _x2, _x3, _x4) {
    return _ref.apply(this, arguments);
  };
}();

exports.formatCards = formatCards;

var formatDeck =
/*#__PURE__*/
function () {
  var _ref2 = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee2(projectRoot, config, data, renderings, deckKey) {
    var output, svg, png, promises, converter, i;
    return _regenerator.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return deckFolder(projectRoot, deckKey);

          case 2:
            output = _context2.sent;
            svg = config.format.includes("svg");
            png = config.format.includes("png");
            promises = [];
            converter = (0, _convertSvgToPng.createConverter)();
            _context2.prev = 7;
            console.log("...saving files");
            i = 0;

          case 10:
            if (!(i < renderings.length)) {
              _context2.next = 19;
              break;
            }

            process.stdout.write(".");

            if (svg) {
              promises.push(formatSvg(renderings[i], i, output));
            }

            if (!png) {
              _context2.next = 16;
              break;
            }

            _context2.next = 16;
            return formatPng(converter, renderings[i], i, output);

          case 16:
            i++;
            _context2.next = 10;
            break;

          case 19:
            _context2.prev = 19;
            converter.destroy();
            process.stdout.write("\n");
            return _context2.finish(19);

          case 23:
            _context2.next = 25;
            return _promise.default.all(promises);

          case 25:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, this, [[7,, 19, 23]]);
  }));

  return function formatDeck(_x5, _x6, _x7, _x8, _x9) {
    return _ref2.apply(this, arguments);
  };
}();

var formatSvg =
/*#__PURE__*/
function () {
  var _ref3 = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee3(rendering, idx, output) {
    return _regenerator.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return _fsp.default.writeFile(svgname(idx, output), rendering.svg);

          case 2:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function formatSvg(_x10, _x11, _x12) {
    return _ref3.apply(this, arguments);
  };
}();

var formatPng =
/*#__PURE__*/
function () {
  var _ref4 = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee4(converter, rendering, idx, output) {
    var png;
    return _regenerator.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return converter.convert(rendering.svg, {
              width: rendering.width,
              height: rendering.height
            });

          case 2:
            png = _context4.sent;
            _context4.next = 5;
            return _fsp.default.writeFile(pngname(idx, output), png);

          case 5:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));

  return function formatPng(_x13, _x14, _x15, _x16) {
    return _ref4.apply(this, arguments);
  };
}();

var svgname = function svgname(rowIdx, output) {
  return _path.default.join(output, "".concat(filename(rowIdx), ".svg"));
};

var pngname = function pngname(rowIdx, output) {
  return _path.default.join(output, "".concat(filename(rowIdx), ".png"));
};

var filename = function filename(rowIdx) {
  return "card_".concat(rowIdx);
};

var deckFolder =
/*#__PURE__*/
function () {
  var _ref5 = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee5(projectRoot, deckKey) {
    var output, folder;
    return _regenerator.default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            output = _path.default.join(projectRoot, "output");
            folder = _path.default.join(output, deckKey);
            _context5.next = 4;
            return _fsp.default.exists(output);

          case 4:
            if (_context5.sent) {
              _context5.next = 7;
              break;
            }

            _context5.next = 7;
            return _fsp.default.mkdir(output);

          case 7:
            _context5.next = 9;
            return _fsp.default.exists(folder);

          case 9:
            if (!_context5.sent) {
              _context5.next = 11;
              break;
            }

            _rimraf.default.sync(folder);

          case 11:
            _context5.next = 13;
            return _fsp.default.exists(folder);

          case 13:
            if (_context5.sent) {
              _context5.next = 16;
              break;
            }

            _context5.next = 16;
            return _fsp.default.mkdir(folder);

          case 16:
            return _context5.abrupt("return", folder);

          case 17:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5, this);
  }));

  return function deckFolder(_x17, _x18) {
    return _ref5.apply(this, arguments);
  };
}();