"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.renderTemplates = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime-corejs2/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/asyncToGenerator"));

var _path = _interopRequireDefault(require("path"));

var _rimraf = _interopRequireDefault(require("rimraf"));

var _react = _interopRequireDefault(require("react"));

var _fsp = _interopRequireDefault(require("./utils/fsp"));

var _transform = require("./utils/transform");

var _server = require("react-dom/server");

var renderTemplates =
/*#__PURE__*/
function () {
  var _ref = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee(projectRoot, config, data) {
    var renderings, templatesPath, tmpPath, deckKey;
    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            renderings = {};
            templatesPath = _path.default.join(projectRoot, "templates");
            tmpPath = _path.default.join(projectRoot, "_tmp");
            _context.next = 5;
            return transpileTemplates(templatesPath, tmpPath);

          case 5:
            _context.t0 = _regenerator.default.keys(config);

          case 6:
            if ((_context.t1 = _context.t0()).done) {
              _context.next = 13;
              break;
            }

            deckKey = _context.t1.value;
            _context.next = 10;
            return renderTemplate(tmpPath, config[deckKey], data[deckKey]);

          case 10:
            renderings[deckKey] = _context.sent;
            _context.next = 6;
            break;

          case 13:
            _rimraf.default.sync(tmpPath);

            return _context.abrupt("return", renderings);

          case 15:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function renderTemplates(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();

exports.renderTemplates = renderTemplates;

var transpileTemplates =
/*#__PURE__*/
function () {
  var _ref2 = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee2(projectRoot, tmpPath) {
    var babel;
    return _regenerator.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            babel = {
              presets: ["@babel/preset-env", "@babel/preset-react"]
            };
            _context2.prev = 1;
            _context2.next = 4;
            return _fsp.default.readJson(_path.default.join(projectRoot, ".babelrc"));

          case 4:
            babel = _context2.sent;
            _context2.next = 9;
            break;

          case 7:
            _context2.prev = 7;
            _context2.t0 = _context2["catch"](1);

          case 9:
            _context2.next = 11;
            return (0, _transform.transformDir)(projectRoot, tmpPath, {
              babel: babel
            });

          case 11:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, this, [[1, 7]]);
  }));

  return function transpileTemplates(_x4, _x5) {
    return _ref2.apply(this, arguments);
  };
}();

var renderTemplate =
/*#__PURE__*/
function () {
  var _ref3 = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee3(templatesPath, config, data) {
    var templatePath, Card, renderings, rowIdx, row, dom, svg;
    return _regenerator.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            templatePath = _path.default.resolve(_path.default.join(templatesPath, config.templateFront));
            Card = require(templatePath).default;
            renderings = [];

            for (rowIdx = 0; rowIdx < data.length; rowIdx++) {
              row = data[rowIdx];
              dom = _react.default.createElement("svg", {
                xmlns: "http://www.w3.org/2000/svg"
              }, _react.default.createElement("g", null, _react.default.createElement("rect", {
                x: "0",
                y: "0",
                width: config.width,
                height: config.height,
                strokeWidth: "0",
                fill: "none"
              })), _react.default.createElement(Card, row));
              svg = (0, _server.renderToStaticMarkup)(dom);
              renderings.push({
                svg: svg,
                width: config.width,
                height: config.height
              });
            }

            return _context3.abrupt("return", renderings);

          case 5:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function renderTemplate(_x6, _x7, _x8) {
    return _ref3.apply(this, arguments);
  };
}();