"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.transform = exports.transformDir = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime-corejs2/regenerator"));

var _promise = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/promise"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/objectSpread"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/asyncToGenerator"));

var _fsp = _interopRequireDefault(require("./fsp"));

var _core = require("@babel/core");

var globby = require("globby");

var path = require("path");

var transformDir =
/*#__PURE__*/
function () {
  var _ref = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee(src, dest, options) {
    var t;
    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            src = path.resolve(src);
            dest = path.resolve(dest);
            _context.next = 4;
            return _fsp.default.exists(dest);

          case 4:
            if (_context.sent) {
              _context.next = 7;
              break;
            }

            _context.next = 7;
            return _fsp.default.mkdir(dest);

          case 7:
            t = function t(file) {
              return transform(file, src, dest, (0, _objectSpread2.default)({
                filename: file
              }, options));
            };

            return _context.abrupt("return", globby("**/*.js", {
              cwd: src
            }).then(function (files) {
              return _promise.default.all(files.map(t));
            }));

          case 9:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function transformDir(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();

exports.transformDir = transformDir;

var transform =
/*#__PURE__*/
function () {
  var _ref2 = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee2(file, src, dest) {
    var _ref3,
        babel,
        onFile,
        filePath,
        destPath,
        _ref4,
        code,
        _args2 = arguments;

    return _regenerator.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _ref3 = _args2.length > 3 && _args2[3] !== undefined ? _args2[3] : {}, babel = _ref3.babel, onFile = _ref3.onFile;
            filePath = path.join(src, file);
            destPath = path.join(dest, file);
            _context2.next = 5;
            return (0, _core.transformFileAsync)(filePath, babel);

          case 5:
            _ref4 = _context2.sent;
            code = _ref4.code;
            return _context2.abrupt("return", _fsp.default.writeFile(destPath, code).then(function () {
              onFile && onFile(file);
            }));

          case 8:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function transform(_x4, _x5, _x6) {
    return _ref2.apply(this, arguments);
  };
}();

exports.transform = transform;