"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Text = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _splittext = require("../lib/splittext");

var _downvg = require("../lib/downvg");

var Text = function Text(_ref) {
  var _ref$lineHeight = _ref.lineHeight,
      lineHeight = _ref$lineHeight === void 0 ? "22px" : _ref$lineHeight,
      _ref$fontSize = _ref.fontSize,
      fontSize = _ref$fontSize === void 0 ? "12px" : _ref$fontSize,
      _ref$fontFamily = _ref.fontFamily,
      fontFamily = _ref$fontFamily === void 0 ? "Helvetica" : _ref$fontFamily,
      _ref$fontStyle = _ref.fontStyle,
      fontStyle = _ref$fontStyle === void 0 ? "regular" : _ref$fontStyle,
      _ref$baseline = _ref.baseline,
      baseline = _ref$baseline === void 0 ? "hanging" : _ref$baseline,
      children = _ref.children,
      color = _ref.color,
      x = _ref.x,
      y = _ref.y,
      props = (0, _objectWithoutProperties2.default)(_ref, ["lineHeight", "fontSize", "fontFamily", "fontStyle", "baseline", "children", "color", "x", "y"]);
  var lines = (0, _splittext.splitText)(children, props.width, {
    fontFamily: fontFamily,
    fontSize: fontSize,
    lineHeight: lineHeight
  });

  var spans = _lodash.default.map(lines, function (l, i) {
    return _react.default.createElement("tspan", {
      key: i,
      x: x,
      dy: i > 0 ? lineHeight : undefined,
      dangerouslySetInnerHTML: {
        __html: (0, _downvg.downvg)(l)
      },
      dominantBaseline: "no-change"
    });
  });

  return _react.default.createElement(_react.default.Fragment, null, children && _react.default.createElement("text", (0, _extends2.default)({
    dominantBaseline: baseline,
    fontFamily: fontFamily,
    fontSize: fontSize,
    fontStyle: fontStyle,
    fill: color,
    y: y
  }, props), spans));
};

exports.Text = Text;