"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.downvg = void 0;
var rules = [{
  regex: /(\*\*|__)(.*?)\1/g,
  replacement: "<strong>$2</strong>"
}, // bold
{
  regex: /(\*|_)(.*?)\1/g,
  replacement: "<em>$2</em>"
}, // emphasis
{
  regex: /\~\~(.*?)\~\~/g,
  replacement: "<del>$1</del>"
}, // del
{
  regex: /`(.*?)`/g,
  replacement: "<code>$1</code>" // inline code

}];

var downvg = function downvg(text) {
  text = "\n" + text + "\n";
  rules.forEach(function (rule) {
    text = text.replace(rule.regex, rule.replacement);
  });
  return text.trim();
};

exports.downvg = downvg;